diff -ru jde-2.2.9beta12/lisp/ChangeLog xemacs-packages/jde/lisp/ChangeLog
--- jde-2.2.9beta12/lisp/ChangeLog	2002-09-10 19:24:58.000000000 -0700
+++ xemacs-packages/jde/lisp/ChangeLog	2002-09-13 08:51:54.000000000 -0700
@@ -1,4 +1,15 @@
+2002-09-13  Andy Piper  <andy@xemacs.org>
+
+	* jde-checkstyle.el (jde-checkstyle-exec): use jde-build-classpath
+	so that things work under cygwin XEmacs.
+
+	* jde-java-font-lock.el (jde-java-font-lock-html-tag-regexp):
+	required during compilation.
+	(jde-java-font-lock-def-html-keyword): keyword is not used.
+
+	* jde-wiz.el (semantic-util): Require semantic-util.
+
 2001-02-22  paulk@PAULK_HOMEPC  <paulk@PAULK_HOMEPC>
 
 	* /pack/anoncvs/jde/lisp/ReleaseNotes.txt: JDE 2.2.7beta2 notes.
diff -ru jde-2.2.9beta12/lisp/jde-checkstyle.el xemacs-packages/jde/lisp/jde-checkstyle.el
--- jde-2.2.9beta12/lisp/jde-checkstyle.el	2002-09-10 19:24:58.000000000 -0700
+++ xemacs-packages/jde/lisp/jde-checkstyle.el	2002-09-13 08:51:00.000000000 -0700
@@ -815,8 +815,9 @@
 	 (args (append
 		(jde-checkstyle-get-options)
 		(oref this :interactive-args)
-		(list "-classpath" 		     
-		      (expand-file-name "lib/checkstyle-all.jar" jde-java-directory))
+		(list "-classpath" 	
+		      (jde-build-classpath
+		       (list (expand-file-name "lib/checkstyle-all.jar" jde-java-directory))))
 		(list jde-checkstyle-class)
 		(list source-file))))
 
diff -ru jde-2.2.9beta12/lisp/jde-java-font-lock.el xemacs-packages/jde/lisp/jde-java-font-lock.el
--- jde-2.2.9beta12/lisp/jde-java-font-lock.el	2002-09-10 19:24:56.000000000 -0700
+++ xemacs-packages/jde/lisp/jde-java-font-lock.el	2002-09-13 08:37:14.000000000 -0700
@@ -411,29 +411,30 @@
     1 jde-java-font-lock-link-face t)
   "Font lock keyword for javadoc HTML A HREF anchor.")
 
-(defun jde-java-font-lock-html-tag-regexp (tag &rest aliases)
-  "Return a regexp that matches HTML tag TAG.
+(eval-and-compile
+  (defun jde-java-font-lock-html-tag-regexp (tag &rest aliases)
+    "Return a regexp that matches HTML tag TAG.
 The string between <TAG> and </TAG> is the second parenthesized
 expression in the returned regexp.  ALIASES are other names for TAG."
-  (let* ((tag-re (mapconcat
-                  #'(lambda (tag)
-                      (mapconcat #'(lambda (c)
-                                     (format "[%c%c]"
-                                             (upcase c)
-                                             (downcase c)))
-                                 tag
-                                 ""))
-                  (cons tag aliases)
-                  "\\|"))
-         (hit-re (if (or (featurep 'xemacs)
-                         (< emacs-major-version 21))
-                     ".*"
-                   ;; In GNU Emacs 21 use the "non-greedy" variant of
-                   ;; the operator `*' to match the smallest possible
-                   ;; substring.
-                   "\\(.\\|[\r\n]\\)*?")))
-    (format "<\\(%s\\)>\\(%s\\)</\\(%s\\)>" tag-re hit-re tag-re)
-    ))
+    (let* ((tag-re (mapconcat
+		    #'(lambda (tag)
+			(mapconcat #'(lambda (c)
+				       (format "[%c%c]"
+					       (upcase c)
+					       (downcase c)))
+				   tag
+				   ""))
+		    (cons tag aliases)
+		    "\\|"))
+	   (hit-re (if (or (featurep 'xemacs)
+			   (< emacs-major-version 21))
+		       ".*"
+		     ;; In GNU Emacs 21 use the "non-greedy" variant of
+		     ;; the operator `*' to match the smallest possible
+		     ;; substring.
+		     "\\(.\\|[\r\n]\\)*?")))
+      (format "<\\(%s\\)>\\(%s\\)</\\(%s\\)>" tag-re hit-re tag-re)
+      )))
 
 (defvar jde-java-font-lock-html-keywords nil
   "List of HTML keywords defined so far.")
@@ -442,8 +443,8 @@
   "Define a font-lock keyword for HTML TAG.
 Data inside TAG will be highlighted with FACE.
 A new keyword is pushed into `jde-java-font-lock-html-keywords'."
-  (let* ((matcher (intern (format "jde-java-font-lock-html-%s-matcher" tag)))
-         (keyword (intern (format "jde-java-font-lock-html-%s-keyword" tag))))
+  (let* ((matcher (intern (format "jde-java-font-lock-html-%s-matcher" tag))))
+;         (keyword (intern (format "jde-java-font-lock-html-%s-keyword" tag))))
     `(progn
        (add-to-list 'jde-java-font-lock-html-keywords '(,matcher 2 ,face t))
        (defun ,matcher (end)
diff -ru jde-2.2.9beta12/lisp/jde-wiz.el xemacs-packages/jde/lisp/jde-wiz.el
--- jde-2.2.9beta12/lisp/jde-wiz.el	2002-09-10 21:29:18.000000000 -0700
+++ xemacs-packages/jde/lisp/jde-wiz.el	2002-09-13 08:24:21.000000000 -0700
@@ -21,6 +21,7 @@
 ;; Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 ;; Boston, MA 02111-1307, USA.
 
+(require 'semantic-util)
 (require 'beanshell)
 (require 'jde-complete)
 (require 'efc)