? build.log
? build.sh
? gdb.log
? linux-build.patch
? lib-src/make-dump-id
? lisp/mule/auto-autoloads.el
? lisp/mule/custom-load.el
? src/NOBYTECOMPILE
Index: version.sh
===================================================================
RCS file: /usr/CVSroot/XEmacs/xemacs/version.sh,v
retrieving revision 1.168.2.1
diff -u -r1.168.2.1 version.sh
--- version.sh	2001/08/19 12:13:49	1.168.2.1
+++ version.sh	2001/08/22 03:19:15
@@ -2,7 +2,7 @@
 emacs_is_beta=t
 emacs_major_version=21
 emacs_minor_version=5
-emacs_beta_version=2
+emacs_beta_version=200
 xemacs_codename="artichoke"
 infodock_major_version=4
 infodock_minor_version=0
Index: src/file-coding.c
===================================================================
RCS file: /usr/CVSroot/XEmacs/xemacs/src/file-coding.c,v
retrieving revision 1.16.2.6
diff -u -r1.16.2.6 file-coding.c
--- src/file-coding.c	2001/08/20 10:38:06	1.16.2.6
+++ src/file-coding.c	2001/08/22 03:19:25
@@ -3173,6 +3173,71 @@
 /*                           ISO2022 methods                            */
 /************************************************************************/
 
+/* Flags indicating what we've seen so far when parsing an
+   ISO2022 escape sequence. */
+enum iso_esc_flag
+{
+  /* Partial sequences */
+  ISO_ESC_NOTHING,	/* Nothing has been seen. */
+  ISO_ESC,		/* We've seen ESC. */
+  ISO_ESC_2_4,		/* We've seen ESC $.  This indicates
+			   that we're designating a multi-byte, rather
+			   than a single-byte, character set. */
+  ISO_ESC_2_8,		/* We've seen ESC 0x28, i.e. ESC (.
+			   This means designate a 94-character
+			   character set into G0. */
+  ISO_ESC_2_9,		/* We've seen ESC 0x29 -- designate a
+			   94-character character set into G1. */
+  ISO_ESC_2_10,		/* We've seen ESC 0x2A. */
+  ISO_ESC_2_11,		/* We've seen ESC 0x2B. */
+  ISO_ESC_2_12,		/* We've seen ESC 0x2C -- designate a
+			   96-character character set into G0.
+			   (This is not ISO2022-standard.
+			   The following 96-character
+			   control sequences are standard,
+			   though.) */
+  ISO_ESC_2_13,		/* We've seen ESC 0x2D -- designate a
+			   96-character character set into G1.
+			   */
+  ISO_ESC_2_14,		/* We've seen ESC 0x2E. */
+  ISO_ESC_2_15,		/* We've seen ESC 0x2F. */
+  ISO_ESC_2_4_8,	/* We've seen ESC $ 0x28 -- designate
+			   a 94^N character set into G0. */
+  ISO_ESC_2_4_9,	/* We've seen ESC $ 0x29. */
+  ISO_ESC_2_4_10,	/* We've seen ESC $ 0x2A. */
+  ISO_ESC_2_4_11,	/* We've seen ESC $ 0x2B. */
+  ISO_ESC_2_4_12,	/* We've seen ESC $ 0x2C. */
+  ISO_ESC_2_4_13,	/* We've seen ESC $ 0x2D. */
+  ISO_ESC_2_4_14,	/* We've seen ESC $ 0x2E. */
+  ISO_ESC_2_4_15,	/* We've seen ESC $ 0x2F. */
+  ISO_ESC_5_11,		/* We've seen ESC [ or 0x9B.  This
+			   starts a directionality-control
+			   sequence.  The next character
+			   must be 0, 1, 2, or ]. */
+  ISO_ESC_5_11_0,	/* We've seen 0x9B 0.  The next character must be ]. */
+  ISO_ESC_5_11_1,	/* We've seen 0x9B 1.  The next character must be ]. */
+  ISO_ESC_5_11_2,	/* We've seen 0x9B 2.  The next character must be ]. */
+
+  /* Full sequences. */
+  ISO_ESC_START_COMPOSITE, /* Private usage for START COMPOSING */
+  ISO_ESC_END_COMPOSITE,   /* Private usage for END COMPOSING */
+  ISO_ESC_SINGLE_SHIFT, /* We've seen a complete single-shift sequence. */
+  ISO_ESC_LOCKING_SHIFT,/* We've seen a complete locking-shift sequence. */
+  ISO_ESC_DESIGNATE,	/* We've seen a complete designation sequence. */
+  ISO_ESC_DIRECTIONALITY,/* We've seen a complete ISO6429 directionality
+			   sequence. */
+  ISO_ESC_LITERAL	/* We've seen a literal character ala
+			   escape-quoting. */
+};
+
+enum iso_error
+{
+  ISO_ERROR_BAD_FINAL,
+  ISO_ERROR_UNKWOWN_ESC_SEQUENCE,
+  ISO_ERROR_INVALID_CODE_POINT_CHARACTER,
+};
+
+
 DEFINE_CODING_SYSTEM_TYPE (iso2022);
 
 struct iso2022_coding_system
@@ -3327,69 +3392,6 @@
   { XD_END }
 };
 
-/* Flags indicating what we've seen so far when parsing an
-   ISO2022 escape sequence. */
-enum iso_esc_flag
-{
-  /* Partial sequences */
-  ISO_ESC_NOTHING,	/* Nothing has been seen. */
-  ISO_ESC,		/* We've seen ESC. */
-  ISO_ESC_2_4,		/* We've seen ESC $.  This indicates
-			   that we're designating a multi-byte, rather
-			   than a single-byte, character set. */
-  ISO_ESC_2_8,		/* We've seen ESC 0x28, i.e. ESC (.
-			   This means designate a 94-character
-			   character set into G0. */
-  ISO_ESC_2_9,		/* We've seen ESC 0x29 -- designate a
-			   94-character character set into G1. */
-  ISO_ESC_2_10,		/* We've seen ESC 0x2A. */
-  ISO_ESC_2_11,		/* We've seen ESC 0x2B. */
-  ISO_ESC_2_12,		/* We've seen ESC 0x2C -- designate a
-			   96-character character set into G0.
-			   (This is not ISO2022-standard.
-			   The following 96-character
-			   control sequences are standard,
-			   though.) */
-  ISO_ESC_2_13,		/* We've seen ESC 0x2D -- designate a
-			   96-character character set into G1.
-			   */
-  ISO_ESC_2_14,		/* We've seen ESC 0x2E. */
-  ISO_ESC_2_15,		/* We've seen ESC 0x2F. */
-  ISO_ESC_2_4_8,	/* We've seen ESC $ 0x28 -- designate
-			   a 94^N character set into G0. */
-  ISO_ESC_2_4_9,	/* We've seen ESC $ 0x29. */
-  ISO_ESC_2_4_10,	/* We've seen ESC $ 0x2A. */
-  ISO_ESC_2_4_11,	/* We've seen ESC $ 0x2B. */
-  ISO_ESC_2_4_12,	/* We've seen ESC $ 0x2C. */
-  ISO_ESC_2_4_13,	/* We've seen ESC $ 0x2D. */
-  ISO_ESC_2_4_14,	/* We've seen ESC $ 0x2E. */
-  ISO_ESC_2_4_15,	/* We've seen ESC $ 0x2F. */
-  ISO_ESC_5_11,		/* We've seen ESC [ or 0x9B.  This
-			   starts a directionality-control
-			   sequence.  The next character
-			   must be 0, 1, 2, or ]. */
-  ISO_ESC_5_11_0,	/* We've seen 0x9B 0.  The next character must be ]. */
-  ISO_ESC_5_11_1,	/* We've seen 0x9B 1.  The next character must be ]. */
-  ISO_ESC_5_11_2,	/* We've seen 0x9B 2.  The next character must be ]. */
-
-  /* Full sequences. */
-  ISO_ESC_START_COMPOSITE, /* Private usage for START COMPOSING */
-  ISO_ESC_END_COMPOSITE,   /* Private usage for END COMPOSING */
-  ISO_ESC_SINGLE_SHIFT, /* We've seen a complete single-shift sequence. */
-  ISO_ESC_LOCKING_SHIFT,/* We've seen a complete locking-shift sequence. */
-  ISO_ESC_DESIGNATE,	/* We've seen a complete designation sequence. */
-  ISO_ESC_DIRECTIONALITY,/* We've seen a complete ISO6429 directionality
-			   sequence. */
-  ISO_ESC_LITERAL	/* We've seen a literal character ala
-			   escape-quoting. */
-};
-
-enum iso_error
-{
-  ISO_ERROR_BAD_FINAL,
-  ISO_ERROR_UNKWOWN_ESC_SEQUENCE,
-  ISO_ERROR_INVALID_CODE_POINT_CHARACTER,
-};
 
 /* The following note taken directly from FSF 21.0.103. */
 
Index: src/lread.c
===================================================================
RCS file: /usr/CVSroot/XEmacs/xemacs/src/lread.c,v
retrieving revision 1.44.2.4
diff -u -r1.44.2.4 lread.c
--- src/lread.c	2001/06/24 09:49:25	1.44.2.4
+++ src/lread.c	2001/08/22 03:19:26
@@ -38,7 +38,9 @@
 
 #include "sysfile.h"
 #include "sysfloat.h"
+#ifdef WIN32_NATIVE
 #include "nt.h"
+#endif
 
 Lisp_Object Qread_char, Qstandard_input;
 Lisp_Object Qvariable_documentation;
Index: src/sysdep.c
===================================================================
RCS file: /usr/CVSroot/XEmacs/xemacs/src/sysdep.c,v
retrieving revision 1.44.2.7
diff -u -r1.44.2.7 sysdep.c
--- src/sysdep.c	2001/08/16 01:50:10	1.44.2.7
+++ src/sysdep.c	2001/08/22 03:19:27
@@ -2516,7 +2516,7 @@
       return res;
     return _open (path, oflag | _O_NOINHERIT, mode);
   }
-#elif INTERRUPTIBLE_OPEN
+#elif defined(INTERRUPTIBLE_OPEN)
   {
     int rtnval;
     while ((rtnval = open (path, oflag, mode)) == -1
Index: src/systime.h
===================================================================
RCS file: /usr/CVSroot/XEmacs/xemacs/src/systime.h,v
retrieving revision 1.11.2.5
diff -u -r1.11.2.5 systime.h
--- src/systime.h	2001/08/16 01:50:12	1.11.2.5
+++ src/systime.h	2001/08/22 03:19:27
@@ -34,7 +34,7 @@
 # endif
 #endif
 
-#ifdef CYGWIN
+#if defined (CYGWIN) || defined (__linux__)
 /* #### why don't other systems have problems with this?  need this
    for struct tms */
 # include <sys/times.h>
Index: src/text.h
===================================================================
RCS file: /usr/CVSroot/XEmacs/xemacs/src/Attic/text.h,v
retrieving revision 1.1.2.8
diff -u -r1.1.2.8 text.h
--- src/text.h	2001/08/16 01:50:13	1.1.2.8
+++ src/text.h	2001/08/22 03:19:27
@@ -2008,7 +2008,7 @@
 /* Like strcmp, except first arg points at internally formatted data,
    while the second points at a string of only ASCII chars. */
 DECLARE_INLINE_HEADER (
-bufbyte_strcmp (const Bufbyte *bp, const char *ascii_string)
+int bufbyte_strcmp (const Bufbyte *bp, const char *ascii_string)
 )
 {
 #ifdef MULE
@@ -2032,7 +2032,7 @@
    while the second points at a string of only ASCII chars. */
 
 DECLARE_INLINE_HEADER (
-bufbyte_memcmp (const Bufbyte *bp, const char *ascii_string, Memory_Count len)
+int bufbyte_memcmp (const Bufbyte *bp, const char *ascii_string, Memory_Count len)
 )
 {
 #ifdef MULE