--- xemacs.mak	Tue May  4 07:31:30 1999
+++ xemacs.nk	Tue May  4 07:26:42 1999
@@ -361,8 +361,7 @@
 XEMACS_INCLUDES=\
  $(XEMACS)\src\config.h \
  $(XEMACS)\src\Emacs.ad.h \
- $(XEMACS)\src\paths.h \
- $(XEMACS)\src\puresize-adjust.h
+ $(XEMACS)\src\paths.h
 
 $(XEMACS)\src\config.h:	config.h
 	copy config.h $(XEMACS)\src
@@ -373,9 +372,6 @@
 $(XEMACS)\src\paths.h:	paths.h
 	copy paths.h $(XEMACS)\src
 
-$(XEMACS)\src\puresize-adjust.h:	puresize-adjust.h
-	copy puresize-adjust.h $(XEMACS)\src
-
 #------------------------------------------------------------------------------
 
 # lib-src programs
@@ -868,7 +864,7 @@
 $(OUTDIR)\TransientEmacsShell.obj: $(TEMACS_SRC)\EmacsShell-sub.c
 	$(CCV) $(TEMACS_CPP_FLAGS) -DDEFINE_TRANSIENT_EMACS_SHELL $** -Fo$@
 
-$(OUTDIR)\alloc.obj: $(TEMACS_SRC)\alloc.c $(TEMACS_SRC)\puresize-adjust.h
+$(OUTDIR)\alloc.obj: $(TEMACS_SRC)\alloc.c
 
 #$(TEMACS_SRC)\Emacs.ad.h: $(XEMACS)\etc\Emacs.ad
 #	!"sed -f ad2c.sed < $(XEMACS)\etc\Emacs.ad > $(TEMACS_SRC)\Emacs.ad.h"
@@ -972,7 +968,6 @@
 	del *.res
 	del *.sbr
 	cd $(XEMACS)\$(TEMACS_DIR)
-	del puresize-adjust.h
 	del config.h
 	del paths.h
 	del Emacs.ad.h